* forecasting- net acquisition
* On every things
* On one APF variable

 
* Zhuoshi Liu @ MFAD,MA,BOE 27 Aug 2012

* install estout

*ssc install estout, replace


* set path

*cd "C:\ZL_folder\BOE_A\Projects\16_WP_LongTerm_Investors_AssetAllocation\analysis\stata\ONSFA\2012q4\"
cd "C:\Users\it237\Documents\Work\savings\pensions\annuity\Pension_and_Gilts\Bank of England\Data\ONS"

* clear memory

clear all


* import data to Stata

*do "loadData.do"

use "DataAll.dta"

do "main3_select.do"
	   
* set dates

tsset  Stata_Dates, quarterly

g 	org_NA_Gilts_ICPF=NA_Gilts_ICPF
g	org_NA_AllcorpBnds_ICPF=NA_AllcorpBnds_ICPF
g	org_NA_AllShares_ICPF=NA_AllShares_ICPF
g	org_NA_Cash_ICPF=NA_Cash_ICPF
	
**********************************
*program: forecast 
**********************************

* from 2009
capture program drop forecast_prog_a
program define forecast_prog_a
args new_v forecast_m1 Stata_Dates
tempvar new_hat new_hat_0

local i = 196 
* the corresponding date is 2009q1

predict `new_hat_0'

while `i'<=211{
* the corresponding date is 2012q4
predict `new_hat'
replace `new_v' = `new_hat' if `Stata_Dates' == `i'
drop `new_hat'
local i = `i'+1
}
g `forecast_m1'  = `new_v'

replace `forecast_m1' = `new_hat_0' if `Stata_Dates' < 196

end


***********************************
*Model FORECAST 
***********************************
*-----M0

* one period ahead estimation based on full sample
estimates restore model_1a
predict NA_Gilts_ICPF_fc0

estimates restore model_1g
predict NA_AllcorpBnds_ICPF_fc0

estimates restore model_1h
predict NA_AllShares_ICPF_fc0

estimates restore model_1b
predict NA_Cash_ICPF_fc0


*-----M1_A


estimates restore model_1a
forecast_prog_a NA_Gilts_ICPF NA_Gilts_ICPF_fc1A Stata_Dates

estimates restore model_1g
forecast_prog_a NA_AllcorpBnds_ICPF NA_AllcorpBnds_ICPF_fc1A Stata_Dates

estimates restore model_1h
forecast_prog_a NA_AllShares_ICPF NA_AllShares_ICPF_fc1A Stata_Dates

estimates restore model_1b
forecast_prog_a NA_Cash_ICPF NA_Cash_ICPF_fc1A Stata_Dates

*-----M1_B

g  old_APF = UK_BOE_APF
replace UK_BOE_APF=0

estimates restore model_1a
forecast_prog_a NA_Gilts_ICPF NA_Gilts_ICPF_fc1B Stata_Dates

estimates restore model_1g
forecast_prog_a NA_AllcorpBnds_ICPF NA_AllcorpBnds_ICPF_fc1B Stata_Dates

estimates restore model_1h
forecast_prog_a NA_AllShares_ICPF NA_AllShares_ICPF_fc1B Stata_Dates

estimates restore model_1b
forecast_prog_a NA_Cash_ICPF NA_Cash_ICPF_fc1B Stata_Dates

*-----M2



estimates restore model_1a0
forecast_prog_a NA_Gilts_ICPF NA_Gilts_ICPF_fc2 Stata_Dates

estimates restore model_1g0
forecast_prog_a NA_AllcorpBnds_ICPF NA_AllcorpBnds_ICPF_fc2 Stata_Dates

estimates restore model_1h0
forecast_prog_a NA_AllShares_ICPF NA_AllShares_ICPF_fc2 Stata_Dates

estimates restore model_1b0
forecast_prog_a NA_Cash_ICPF NA_Cash_ICPF_fc2 Stata_Dates

replace UK_BOE_APF=old_APF


***********************************
*QE EFFECTS 
***********************************

/*g qe_Gilts_icpf_full = NA_Gilts_ICPF_fc0 - NA_Gilts_ICPF_fc1
g qe_Gilts_icpf_sub  = NA_Gilts_ICPF_fc0 - NA_Gilts_ICPF_fc2

g qe_Corp_icpf_full = NA_AllcorpBnds_ICPF_fc0 - NA_AllcorpBnds_ICPF_fc1
g qe_Corp_icpf_sub  = NA_AllcorpBnds_ICPF_fc0 - NA_AllcorpBnds_ICPF_fc2

g qe_Share_icpf_full = NA_AllShares_ICPF_fc0 - NA_AllShares_ICPF_fc1
g qe_Share_icpf_sub  = NA_AllShares_ICPF_fc0 - NA_AllShares_ICPF_fc2

g qe_Cash_icpf_full = NA_Cash_ICPF_fc0 - NA_Cash_ICPF_fc1
g qe_Cash_icpf_sub  = NA_Cash_ICPF_fc0 - NA_Cash_ICPF_fc2*/

*ex-post: sub sample: true - forecast_2
*ex-ante: full sample: forecast_1 - forecast_2

replace NA_Gilts_ICPF=org_NA_Gilts_ICPF
replace	NA_AllcorpBnds_ICPF=org_NA_AllcorpBnds_ICPF
replace	NA_AllShares_ICPF=org_NA_AllShares_ICPF
replace	NA_Cash_ICPF=org_NA_Cash_ICPF

g qe_Gilts_icpf_full = NA_Gilts_ICPF_fc1A- NA_Gilts_ICPF_fc1B
g qe_Gilts_icpf_sub  = NA_Gilts_ICPF - NA_Gilts_ICPF_fc2

g qe_Corp_icpf_full = NA_AllcorpBnds_ICPF_fc1A - NA_AllcorpBnds_ICPF_fc1B
g qe_Corp_icpf_sub  = NA_AllcorpBnds_ICPF - NA_AllcorpBnds_ICPF_fc2

g qe_Share_icpf_full = NA_AllShares_ICPF_fc1A - NA_AllShares_ICPF_fc1B
g qe_Share_icpf_sub  = NA_AllShares_ICPF - NA_AllShares_ICPF_fc2

g qe_Cash_icpf_full = NA_Cash_ICPF_fc1A - NA_Cash_ICPF_fc1B
g qe_Cash_icpf_sub  = NA_Cash_ICPF - NA_Cash_ICPF_fc2

*Chart - ex ante

twoway (line NA_AllShares_ICPF_fc1A Stata_Dates) (line NA_AllShares_ICPF_fc1B Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Equity) legend(order( 1 "Expected" 2 "Counterfactual" ) size(small))
graph save Graph "NA_equity_ICPF1.gph" , replace

twoway (line NA_Gilts_ICPF_fc1A Stata_Dates) (line NA_Gilts_ICPF_fc1B Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small))  xtitle(Date) title(Govnt bonds) legend(order( 1 "Expected" 2 "Counterfactual"  ) size(small))
graph save Graph "NA_Gilts_ICPF1.gph" , replace

twoway (line NA_AllcorpBnds_ICPF_fc1A Stata_Dates) (line NA_AllcorpBnds_ICPF_fc1B Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small))   xtitle(Date) title(Corp bonds) legend(order( 1 "Expected" 2 "Counterfactual" ) size(small))
graph save Graph "NA_Corp_ICPF1.gph" , replace

twoway (line NA_Cash_ICPF_fc1A Stata_Dates) (line NA_Cash_ICPF_fc1B Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Cash) legend(order( 1 "Expected" 2 "Counterfactual" ) size(small))
graph save Graph "NA_Cash_ICPF1.gph" , replace

graph combine NA_equity_ICPF1.gph NA_Gilts_ICPF1.gph NA_Corp_ICPF1.gph  NA_Cash_ICPF1.gph , row(2)

* chart - ex post

twoway (line NA_AllShares_ICPF Stata_Dates) (line NA_AllShares_ICPF_fc2 Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Equity) legend(order( 1 "Actual" 2 "Counterfactual" ) size(small))
graph save Graph "NA_equity_ICPF1.gph" , replace

twoway (line NA_Gilts_ICPF Stata_Dates) (line NA_Gilts_ICPF_fc2 Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small))  xtitle(Date) title(Govnt bonds) legend(order( 1 "Actual" 2 "Counterfactual"  ) size(small))
graph save Graph "NA_Gilts_ICPF1.gph" , replace

twoway (line NA_AllcorpBnds_ICPF Stata_Dates) (line NA_AllcorpBnds_ICPF_fc2 Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small))   xtitle(Date) title(Corp bonds) legend(order( 1 "Actual" 2 "Counterfactual" ) size(small))
graph save Graph "NA_Corp_ICPF1.gph" , replace

twoway (line NA_Cash_ICPF Stata_Dates) (line NA_Cash_ICPF_fc2 Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Cash) legend(order( 1 "Actual" 2 "Counterfactual" ) size(small))
graph save Graph "NA_Cash_ICPF1.gph" , replace

graph combine NA_equity_ICPF1.gph NA_Gilts_ICPF1.gph NA_Corp_ICPF1.gph  NA_Cash_ICPF1.gph , row(2)

* chart - QE effects

twoway (line qe_Share_icpf_full Stata_Dates) (line qe_Share_icpf_sub Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Equity) legend(order( 1 "ex-ante" 2 "ex-post" ) size(small))
graph save Graph "QE_equity_ICPF1.gph" , replace

twoway (line qe_Gilts_icpf_full Stata_Dates) (line qe_Gilts_icpf_sub Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small))  xtitle(Date) title(Govnt bonds) legend(order( 1 "ex-ante" 2 "ex-post"  ) size(small))
graph save Graph "QE_Gilts_ICPF1.gph" , replace

twoway (line qe_Corp_icpf_full Stata_Dates) (line qe_Corp_icpf_sub Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small))   xtitle(Date) title(Corp bonds) legend(order( 1 "ex-ante" 2 "ex-post" ) size(small))
graph save Graph "QE_Corp_ICPF1.gph" , replace

twoway (line qe_Cash_icpf_full Stata_Dates) (line qe_Cash_icpf_sub Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Cash) legend(order( 1 "ex-ante" 2 "ex-post" ) size(small))
graph save Graph "QE_Cash_ICPF1.gph" , replace

graph combine QE_equity_ICPF1.gph QE_Gilts_ICPF1.gph QE_Corp_ICPF1.gph  QE_Cash_ICPF1.gph , row(2)






/* chart - diff counterfactual

twoway (line NA_AllShares_ICPF_fc2 Stata_Dates) (line NA_AllShares_ICPF_fc1B Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Equity) legend(order( 1 "Counterfactual1" 2 "Counterfactual2" ) size(small))
graph save Graph "NA_equity_ICPF1.gph" , replace

twoway (line NA_Gilts_ICPF_fc2 Stata_Dates) (line NA_Gilts_ICPF_fc1B Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small))  xtitle(Date) title(Govnt bonds) legend(order( 1 "Counterfactual1" 2 "Counterfactual2"  ) size(small))
graph save Graph "NA_Gilts_ICPF1.gph" , replace

twoway (line NA_AllcorpBnds_ICPF_fc2 Stata_Dates) (line NA_AllcorpBnds_ICPF_fc1B Stata_Dates, lpattern(vshortdash)),ylabel(, labsize(vsmall)) xlabel(, labsize(small))   xtitle(Date) title(Corp bonds) legend(order( 1 "Counterfactual1" 2 "Counterfactual2" ) size(small))
graph save Graph "NA_Corp_ICPF1.gph" , replace

twoway (line NA_Cash_ICPF_fc2 Stata_Dates) (line NA_Cash_ICPF_fc1B Stata_Dates, lpattern(vshortdash)), ylabel(, labsize(vsmall)) xlabel(, labsize(small)) xtitle(Date) title(Cash) legend(order( 1 "Counterfactual1" 2 "Counterfactual2" ) size(small))
graph save Graph "NA_Cash_ICPF1.gph" , replace

graph combine NA_equity_ICPF1.gph NA_Gilts_ICPF1.gph NA_Corp_ICPF1.gph  NA_Cash_ICPF1.gph , row(2)
